local ipairs, wipe, CreateFrame, insert, type = ipairs, table.wipe, CreateFrame, table.insert, type;

local ScrollFrames = {}

local function Release(self)
    for i,v in pairs(self) do 
        if type(v) == "table" and v.Release then
            v:Release();
        end
        v = nil
    end 

    --[[
    for i, v in ipairs(self.LM) do
        if type(self[v]) == "table" and self[v].Release then
            self[v]:Release();
        end
        self[v] = nil
    end]]
    wipe(self.LM);
    self:Hide()
    self.Released = true
    self:SetScrollChild(nil)
    self:SetVerticalScroll(0)
    self:SetHorizontalScroll(0)
end

function _Avyr_Global_ADDON_Elements_Lib.WidgetsMixin:CreateScrollFrame(Parent)
    local ScrollFrame
    for i, v in ipairs(ScrollFrames) do
        if v.Released then
            ScrollFrame = v
            ScrollFrame:SetParent(Parent)
            ScrollFrame:Show()
        end
    end
    if not ScrollFrame then
        ScrollFrame = CreateFrame("ScrollFrame", nil, Parent)
        ScrollFrame.LM = {}
        ScrollFrame.Release = Release
        insert(ScrollFrames, ScrollFrame)
    end
    ScrollFrame.Released = false

    return ScrollFrame
end

